#!/usr/bin/perl
use strict;
use warnings;
use XML::LibXML qw(:libxml);
my $filename = shift;
my $dom = XML::LibXML->load_xml(location => $filename);
foreach my $bitrecord ($dom->findnodes('/smbl/bitrecord'))
{
   print "Bitrecord ", $bitrecord->findvalue('@name'),"\n";
   my @prop = grep { $_->nodeType == XML_ELEMENT_NODE } $bitrecord->childNodes;
   print "$#prop Properties:\n";
   foreach my $property (@prop) 
   {
      print ref($property)," name=",$property->nodeName,"\n";
      print $property->{name}," type=",$property->{type}," bitsize=",$property->{bitsize},"\n";
   }
}
